diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 37a8c1c..d404768 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -930,34 +251,18 @@ int main(void)
   MODULE_INIT_HAL_EXTRA();
 #endif /* defined(MODULE_INIT_HAL_EXTRA) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_1)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_1(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_1();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1) */
-
   // ChibiOS/RT kernel and custom kernel additions (if any)
   chSysInit();
 #if defined(MODULE_INIT_KERNEL_EXTRA)
   MODULE_INIT_KERNEL_EXTRA();
 #endif /* defined(MODULE_INIT_KERNEL_EXTRA) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_2)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_2(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_2();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2) */
-
   // AMiRo-OS, additional interrupts and custom OS additions (if any)
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
+#if (AMIROOS_CFG_SHELL_ENABLE == true)
   aosSysInit(moduleShellPrompt);
-#else /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#else /* (AMIROOS_CFG_SHELL_ENABLE == true) */
   aosSysInit();
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 #if defined(MODULE_INIT_INTERRUPTS)
   MODULE_INIT_INTERRUPTS();
 #endif
@@ -965,68 +270,213 @@ int main(void)
   MODULE_INIT_OS_EXTRA();
 #endif /* defined(MODULE_INIT_OS_EXTRA) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_3)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_3(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_3();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3) */
-
   /* event associations */
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
-  ioeventflagsmask |= MODULE_SSSP_EVENTFLAGS_PD | MODULE_SSSP_EVENTFLAGS_SYNC;
+  {
+    eventflags_t flagsmask = AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK | MODULE_SSSP_EVENTFLAG_PD | MODULE_SSSP_EVENTFLAG_S;
 #if (AMIROOS_CFG_SSSP_STACK_START != true)
-  ioeventflagsmask |= MODULE_SSSP_EVENTFLAGS_DN;
+    flagsmask |= MODULE_SSSP_EVENTFLAG_DN;
 #endif /* (AMIROOS_CFG_SSSP_STACK_START != true) */
 #if (AMIROOS_CFG_SSSP_STACK_END != true)
-  ioeventflagsmask |= MODULE_SSSP_EVENTFLAGS_UP;
+    flagsmask |= MODULE_SSSP_EVENTFLAG_UP;
 #endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
+    chEvtRegisterMaskWithFlags(&aos.events.gpio, &_eventListenerGPIO, EVENTMASK_GPIO, flagsmask);
+  }
+#else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+  if (AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) {
+    chEvtRegisterMaskWithFlags(&aos.events.gpio, &_eventListenerGPIO, EVENTMASK_GPIO, AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK);
+  }
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-  if (ioeventflagsmask != 0) {
-    chEvtRegisterMaskWithFlags(&aos.events.io, &_eventListenerIO, IOEVENT_MASK, ioeventflagsmask);
+  chEvtRegisterMask(&aos.events.os, &_eventListenerOS, EVENTMASK_OS);
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_STARTUP == true)
+
+  /* perform SSSP basic initialization stage */
+
+#if defined(MODULE_SSSP_BASICINIT_HOOK)
+#if defined(MODULE_SSSP_BASICINIT_HOOK_ARGS)
+  MODULE_SSSP_BASICINIT_HOOK(MODULE_SSSP_BASICINIT_HOOK_ARGS);
+#else /* defined(MODULE_SSSP_BASICINIT_HOOK_ARGS) */
+  MODULE_SSSP_BASICINIT_HOOK();
+#endif /* defined(MODULE_SSSP_BASICINIT_HOOK_ARGS) */
+#endif /* defined(MODULE_SSSP_BASICINIT_HOOK) */
+
+  // proceed to startup stage 1.2
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(NULL, 0, EVENTMASK_SSSPTIMER, &eventmask) != AOS_SUCCESS)) {
+    /*
+     * This code is executed if the received event was not about the delay.
+     * The received event could be casued by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+      // PD event
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+        shutdown = AOS_SHUTDOWN_PASSIVE;
+      } else {
+#if defined(MODULE_SSSP_STARTUP_1_1_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_1_1_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_1_1_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_1_1_GPIOEVENT_HOOK) */
+      }
+    }
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
   }
-  chEvtRegisterMask(&aos.events.os, &_eventListenerOS, OSEVENT_MASK);
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_1_2);
+  }
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+    aosSsspProceed(NULL, 0, 0, NULL);
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_1_2);
+  }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_4)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_4(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_4();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4) */
+  // proceed to startup stage 1.3
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(&_eventListenerGPIO, MODULE_SSSP_EVENTFLAG_S, EVENTMASK_GPIO, &eventmask) != AOS_SUCCESS)) {
+    /*
+     * This code is executed if the received event was not about a deactivation of the snychronization signal.
+     * The received event could be caused by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+      // PD event
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+        shutdown = AOS_SHUTDOWN_PASSIVE;
+      } else {
+#if defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK) */
+      }
+    }
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
+  }
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_1_3);
+  }
+
+  // proceed to startup stage 2.1
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(NULL, 0, EVENTMASK_SSSPTIMER, &eventmask) != AOS_SUCCESS)) {
+    /*
+     * This code is executed if the received event was not about the delay.
+     * The received event could be caused by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+      // PD event
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+        shutdown = AOS_SHUTDOWN_PASSIVE;
+      } else {
+#if defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK) */
+      }
+    }
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
+  }
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(&_eventListenerGPIO, MODULE_SSSP_EVENTFLAG_S, EVENTMASK_GPIO, &eventmask) != AOS_SUCCES)) {
+    /*
+     * This code is executed if the received event was not about a deactivation of the snychronization signal.
+     * The received event could be caused by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+      // PD event
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+        shutdown = AOS_SHUTDOWN_PASSIVE;
+      } else {
+#if defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_1_2_GPIOEVENT_HOOK) */
+      }
+    }
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
+  }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_2_1);
+  }
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_STARTUP == true) */
+
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_1)
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS)
+  AMIROOS_CFG_MAIN_INIT_HOOK_1(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS) */
+  AMIROOS_CFG_MAIN_INIT_HOOK_1();
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_1) */
 
   /* periphery communication interfaces initialization */
-  // module specific initialization (if any)
 #if defined(MODULE_INIT_PERIPHERY_IF)
+  // module specific initialization
   MODULE_INIT_PERIPHERY_IF();
 #endif /* defined(MODULE_INIT_PERIPHERY_IF) */
-#if ((SSSP_STAGE3_ENABLE == true) && (HAL_USE_CAN == TRUE))
-  // CAN
-  if (MODULE_HAL_CAN.state == CAN_STOP) {
-    canStart(&MODULE_HAL_CAN, &moduleHalCanConfig);
-  }
-#endif /* (SSSP_STAGE3_ENABLE == true) && (HAL_USE_CAN == TRUE) */
-  // user interface (if any)
 #if defined(MODULE_HAL_PROGIF)
+  // user interface
   aosIOChannelInit(&_stdiochannel, (BaseAsynchronousChannel*)&MODULE_HAL_PROGIF);
   aosIOChannelOutputEnable(&_stdiochannel);
   aosIOStreamAddChannel(&aos.iostream, &_stdiochannel);
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
+#if (AMIROOS_CFG_SHELL_ENABLE == true)
   aosShellChannelInit(&_stdshellchannel, (BaseAsynchronousChannel*)&MODULE_HAL_PROGIF);
   aosShellChannelInputEnable(&_stdshellchannel);
   aosShellChannelOutputEnable(&_stdshellchannel);
   aosShellStreamAddChannel(&aos.shell.stream, &_stdshellchannel);
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 #endif /* defined(MODULE_HAL_PROGIF) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_5)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_5(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_5();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5) */
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_2)
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS)
+  AMIROOS_CFG_MAIN_INIT_HOOK_2(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS) */
+  AMIROOS_CFG_MAIN_INIT_HOOK_2();
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2) */
 
   /* module is ready -> print welcome prompt */
   aosprintf("\n");
@@ -1045,13 +495,13 @@ int main(void)
   aosprintf("######################################################################\n");
   aosprintf("\n");
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_6)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_6_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_6(AMIROOS_CFG_MAIN_INIT_HOOK_6_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_6_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_6();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_6_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_6) */
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_3)
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS)
+  AMIROOS_CFG_MAIN_INIT_HOOK_3(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS) */
+  AMIROOS_CFG_MAIN_INIT_HOOK_3();
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_3) */
 
 #if (AMIROOS_CFG_TESTS_ENABLE == true)
 #if defined(MODULE_INIT_TESTS)
@@ -1061,33 +511,35 @@ int main(void)
 #endif /* defined(MODULE_INIT_TESTS) */
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_7)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_7_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_7(AMIROOS_CFG_MAIN_INIT_HOOK_7_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_7_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_7();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_7_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_7) */
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_4)
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS)
+  AMIROOS_CFG_MAIN_INIT_HOOK_4(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS) */
+  AMIROOS_CFG_MAIN_INIT_HOOK_4();
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4) */
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
-  /* SSSP startup OS synchronization phase (end of startup stage 2) */
-  while ((shutdown == AOS_SHUTDOWN_NONE) && (eventmask = aosSysSsspStartupOsInitSyncCheck(&_eventListenerIO)) != 0) {
+
+  // proceed to startup stage 2.2
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(NULL, 0, EVENTMASK_SSSPTIMER, &eventmask) != AOS_SUCCESS)) {
     /*
-     * This code is executed if the received event was not about the SYS_SYNC control signal.
-     * The returned event could be caused by any listener (not only the argument).
+     * This code is executed if the received event was not about the delay.
+     * The received event could be caused by any listener.
      */
-    // IO event
-    if (eventmask & _eventListenerIO.events) {
-      eventflags = chEvtGetAndClearFlags(&_eventListenerIO);
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
       // PD event
-      if (eventflags & MODULE_SSSP_EVENTFLAGS_PD) {
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
         shutdown = AOS_SHUTDOWN_PASSIVE;
       } else {
-#if defined(MODULE_SSSP_STARTUP_2_2_IOEVENT_HOOK)
-        MODULE_SSSP_STARTUP_2_2_IOEVENT_HOOK(eventmask, eventflags);
-#else /* defined(MODULE_SSSP_STARTUP_2_2_IOEVENT_HOOK) */
-        // ignore any other IO events
-#endif /* defined(MODULE_SSSP_STARTUP_2_2_IOEVENT_HOOK) */
+#if defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_1_3_GPIOEVENT_HOOK) */
       }
     }
     // OS event
@@ -1100,104 +552,81 @@ int main(void)
       _unexpectedEventError(eventmask, 0);
     }
   }
-
-#if (HAL_USE_CAN == TRUE)
-
-  /*
-   * There must be no delays at this point, thus no hook is allowed.
-   */
-
-  /* SSSP startup stage 3 (module stack initialization) */
   if (shutdown == AOS_SHUTDOWN_NONE) {
-    shutdown = _ssspModuleStackInitialization();
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_2_2);
   }
-
-  /*
-   * There must be no delays at this point, thus no hook is allowed.
-   */
-
-#if (HAL_USE_RTC == TRUE)
-  /* synchronize calendars */
-  if (shutdown == AOS_SHUTDOWN_NONE) {
-#if (AMIROOS_CFG_SSSP_MASTER == true)
-    CANTxFrame frame;
-    struct tm t;
-    uint64_t encoded;
-
-    frame.DLC = 8;
-    frame.RTR = CAN_RTR_DATA;
-    frame.IDE = CAN_IDE_STD;
-    frame.SID = CALENDERSYNC_CANMSGID;
-
-    aosDbgPrintf("transmitting current date/time...\t");
-    // get current date & time
-    aosSysGetDateTime(&t);
-    // encode
-    encoded = _TM2U64(&t);
-    // serialize
-    _serialize(frame.data8, encoded, 8);
-    // transmit
-    canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE);
-
-    aosDbgPrintf("done\n");
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
-    CANRxFrame frame;
-    uint64_t encoded;
-    struct tm t;
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+    aosSsspProceed(NULL, 0, 0, NULL);
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_2_2);
+  }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
 
-    aosDbgPrintf("receiving current date/time...\t");
-    // receive message
-#if (AMIROOS_CFG_DBG == true)
-    // increase timeout in debug mode due to additional delays introduced by the many prinf() calls
-    if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, chTimeUS2I(10 * AOS_SYSTEM_SSSP_TIMEOUT)) == MSG_OK) {
-#else /* (AMIROOS_CFG_DBG == true) */
-    if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT)) == MSG_OK) {
-#endif /* (AMIROOS_CFG_DBG == true) */
-      // validate message
-      if (frame.DLC == 8 &&
-          frame.RTR == CAN_RTR_DATA &&
-          frame.IDE == CAN_IDE_STD &&
-          frame.SID == CALENDERSYNC_CANMSGID) {
-        // deserialize
-        encoded = _deserialize(frame.data8, 8);
-        // decode
-        _U642TM(&t, encoded);
-        // set current date & time
-        aosSysSetDateTime(&t);
-        aosDbgPrintf("success\n");
+  // proceed to startup stage 3 (MSI is enabled), or to operation phase (no MSI)
+  while ((shutdown == AOS_SHUTDOWN_NONE) && (aosSsspProceed(&_eventListenerGPIO, MODULE_SSSP_EVENTFLAG_S, EVENTMASK_GPIO, &eventmask) != AOS_SUCCESS)) {
+    /*
+     * This code is executed if the received event was not about a deactivation of the snychronization signal.
+     * The received event could be caused by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+      // PD event
+      if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+        shutdown = AOS_SHUTDOWN_PASSIVE;
       } else {
-        aosDbgPrintf("fail (invalid message)\n");
+#if defined(MODULE_SSSP_STARTUP_2_2_GPIOEVENT_HOOK)
+        MODULE_SSSP_STARTUP_2_2_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_STARTUP_2_2_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_STARTUP_2_2_GPIOEVENT_HOOK) */
       }
-    } else {
-      aosDbgPrintf("fail (timeout)\n");
     }
-#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
-    aosDbgPrintf("\n");
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
+  }
+  if (shutdown == AOS_SHUTDOWN_NONE) {
+#if (AMIROOS_CFG_SSSP_MSI == true)
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_1);
+#else /* (AMIROOS_CFG_SSSP_MSI == true) */
+    aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_OPERATION);
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
   }
-#endif /* (HAL_USE_RTC == TRUE) */
-#endif /* (HAL_USE_CAN == TRUE) */
-#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_8)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_8_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_8(AMIROOS_CFG_MAIN_INIT_HOOK_8_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_8_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_8();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_8_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_8) */
+  // start the internal system uptime counter
+  aosSysStartUptime();
+
+  /*
+   * There must be no delays at this point, thus no hook allowed.
+   */
+
+#if (AMIROOS_CFG_SSSP_MSI == true)
+
+  //TODO
+
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
   /* completely start AMiRo-OS */
   if (shutdown == AOS_SHUTDOWN_NONE) {
     aosSysStart();
   }
 
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_9)
-#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_9_ARGS)
-  AMIROOS_CFG_MAIN_INIT_HOOK_9(AMIROOS_CFG_MAIN_INIT_HOOK_9_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_9_ARGS) */
-  AMIROOS_CFG_MAIN_INIT_HOOK_9();
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_9_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_9) */
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_5)
+#if defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS)
+  AMIROOS_CFG_MAIN_INIT_HOOK_5(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS) */
+  AMIROOS_CFG_MAIN_INIT_HOOK_5();
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_5) */
 
   /*
    * ##########################################################################
@@ -1214,60 +643,64 @@ int main(void)
     eventmask = chEvtWaitOne(ALL_EVENTS);
 #endif /* (AMIROOS_CFG_MAIN_LOOP_TIMEOUT != 0) */
 
-#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_0)
-#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_0_ARGS)
-    AMIROOS_CFG_MAIN_LOOP_HOOK_0(AMIROOS_CFG_MAIN_LOOP_HOOK_0_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_0_ARGS) */
-    AMIROOS_CFG_MAIN_LOOP_HOOK_0();
-#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_0_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_0) */
+#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1)
+#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS)
+    AMIROOS_CFG_MAIN_LOOP_HOOK_1(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS) */
+    AMIROOS_CFG_MAIN_LOOP_HOOK_1();
+#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1) */
 
     switch (eventmask) {
-      // if this was an I/O event
-      case IOEVENT_MASK:
+      // if this was an GPIO event
+      case EVENTMASK_GPIO:
         // evaluate flags
-        eventflags = chEvtGetAndClearFlags(&_eventListenerIO);
+        eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
         // PD event
-        if (eventflags & MODULE_SSSP_EVENTFLAGS_PD) {
+        if (eventflags & MODULE_SSSP_EVENTFLAG_PD) {
+          aosSsspShutdownInit();
           shutdown = AOS_SHUTDOWN_PASSIVE;
         }
         // all other events
-#if defined(MODULE_MAIN_LOOP_IO_EVENT)
+#if defined(MODULE_MAIN_LOOP_GPIOEVENT)
         else {
-          MODULE_MAIN_LOOP_IO_EVENT(eventflags);
+          MODULE_MAIN_LOOP_GPIOEVENT(eventflags);
         }
-#endif /* defined(MODULE_MAIN_LOOP_IO_EVENT) */
+#endif /* defined(MODULE_MAIN_LOOP_GPIOEVENT) */
 #else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-#if defined(MODULE_MAIN_LOOP_IO_EVENT)
-        MODULE_MAIN_LOOP_IO_EVENT(eventflags);
-#endif /* defined(MODULE_MAIN_LOOP_IO_EVENT) */
+#if defined(MODULE_MAIN_LOOP_GPIOEVENT)
+        MODULE_MAIN_LOOP_GPIOEVENT(eventflags);
+#endif /* defined(MODULE_MAIN_LOOP_GPIOEVENT) */
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
         break;
 
       // if this was an OS event
-      case OSEVENT_MASK:
+      case EVENTMASK_OS:
         // evaluate flags
         eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
         switch (eventflags) {
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-          case AOS_SYSTEM_EVENTFLAGS_HIBERNATE:
+#if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE)
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_MASK:
+            shutdown = AOS_SHUTDOWN_ACTIVE;
+            break;
+#elif (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_HIBERNATE:
             shutdown = AOS_SHUTDOWN_HIBERNATE;
             break;
-          case AOS_SYSTEM_EVENTFLAGS_DEEPSLEEP:
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_DEEPSLEEP:
             shutdown = AOS_SHUTDOWN_DEEPSLEEP;
             break;
-          case AOS_SYSTEM_EVENTFLAGS_TRANSPORTATION:
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_TRANSPORTATION:
             shutdown = AOS_SHUTDOWN_TRANSPORTATION;
             break;
-          case AOS_SYSTEM_EVENTFLAGS_RESTART:
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_RESTART:
             shutdown = AOS_SHUTDOWN_RESTART;
             break;
-#else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN:
-            shutdown = AOS_SHUTDOWN_DEFAULT;
+          case AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_PASSIVE:
+            _unexpectedEventError(eventmask, eventflags);
             break;
-#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+#endif /* (AMIROOS_CFG_BOOTLOADER == X) */
           default:
             _unexpectedEventError(eventmask, eventflags);
             break;
@@ -1283,13 +716,13 @@ int main(void)
         break;
     }
 
-#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1)
-#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS)
-    AMIROOS_CFG_MAIN_LOOP_HOOK_1(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS) */
-    AMIROOS_CFG_MAIN_LOOP_HOOK_1();
-#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_1) */
+#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_2)
+#if defined(AMIROOS_CFG_MAIN_LOOP_HOOK_2_ARGS)
+    AMIROOS_CFG_MAIN_LOOP_HOOK_2(AMIROOS_CFG_MAIN_LOOP_HOOK_2_ARGS);
+#else /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_2_ARGS) */
+    AMIROOS_CFG_MAIN_LOOP_HOOK_2();
+#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_2_ARGS) */
+#endif /* defined(AMIROOS_CFG_MAIN_LOOP_HOOK_2) */
   }
 
   /*
@@ -1298,33 +731,30 @@ int main(void)
    * ##########################################################################
    */
 
-#if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0)
-#if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0_ARGS)
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0_ARGS);
-#else /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0_ARGS) */
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0();
-#endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0_ARGS) */
-#endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_0) */
+  aosDbgAssert(shutdown != AOS_SHUTDOWN_NONE);
 
   // initialize/acknowledge shutdown
   aosSysShutdownInit(shutdown);
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
+  aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_SHUTDOWN_1_2);
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS)
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS);
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS);
 #else /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS) */
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1();
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1();
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1) */
 
-  // stop system threads
+  // wait for all threads to terminate
   aosSysStop();
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS)
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS);
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS);
 #else /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS) */
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2();
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2();
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2) */
 
@@ -1333,9 +763,9 @@ int main(void)
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS)
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS);
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS);
 #else /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS) */
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3();
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3();
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3) */
 
